#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "forms.h"
#include "interface.h"
#include "spelldb.h"

#define MAXLEN 40
#define RELEASE "BETA"

extern FD_main         		*fd_main;
extern FD_titel        		*fd_titel;
extern FD_setup_form		*fd_setup_form;
extern FD_general_setup 	*fd_general_setup;
extern FD_tradelists_setup 	*fd_tradelists_setup;
extern FD_report		*fd_report;

extern int 		schreiben(char* filename);
extern struct 		karten karte[4000];
extern char 		*serien[];
extern char 		*arten[];
extern char 		*welten[];
extern char		*rarities[];
extern int 		max_karten;
extern short int	current_series;
extern short int	current_nummer;
extern short int 	local_number;
extern char		database_filename[MAXLINE];
extern short int	keep;
extern short int	emit[27];
extern char		versionstr[MAXLEN]; 
extern char		setupfile[MAXLINE];

char *real_serien[]={
                " ","1st Edition","1st Edition Chase","2nd Edition","3rd Editon","4th Edition","Dracononicon","Draconomicon Chase","NightStalkers",
                "NightStalkers Chase","Artifacts","Artifacts Chase","Birthright","Birthright Chase","Dragonlance","Dragonlance Chase",
                "Forgotten Realms","Forgotten Realms Chase","No Edition","Powers","Powers Chase","Promos","Ravenloft","Runes and Ruins",
                "Runes and Ruins Chase","Underdark","Underdark Chase",NULL
              };

char *real_arten[]={
                " ","Ally","Artifact","Blood Ability","Cleric Spell","Cleric",
                "Cleric/Avatar","Event","Hero","Holding","Magical Item",
                "Monster","Psioncist","Psionic Power","Psionicist","Realm",
                "Regent","Rule","Thief Ability","Thief","Unarmed Combat",
                "Wizard Spell","Wizard",NULL
              };

char *real_welten[]={
                 " ","AD&D","Birthright","Dragonlance","Dark Sun","Forgotten Realms","Greyhawk","Ravenloft",NULL
               };

char *real_rarities[]={
                   " ","Common","Realm","Rare","Uncommon","Very Rare",NULL
                 };

int search(int serie, int lokale_nummer)
{
  int i;
  
  // printf("Lokale Nummer: %d Serie: %s ",lokale_nummer,real_serien[serie]);
  i=0;
  while ( i<max_karten && (karte[i].serie!=serie || karte[i].nummer!=lokale_nummer)) 
    {
      i++; 
    } 
  if (karte[i].serie==serie && karte[i].nummer==lokale_nummer) 
      current_nummer=i;
      else 
        {
          fl_set_input(fd_main->i_cardnumber,"");
          fl_ringbell(0);
        }      
  // printf("Globale Nummer: %d\n",current_nummer);
  return i;
} 

void update_data()
{
  char puffer[MAXLEN];
  
  search(current_series,local_number);
  
  fl_set_input(fd_main->d_name,karte[current_nummer].name);

  sprintf(puffer,"%d",karte[current_nummer].anzahl);
  fl_set_input(fd_main->d_inventory,puffer);

  fl_set_input(fd_main->d_welt,real_welten[karte[current_nummer].welt]);
  
  sprintf(puffer,"%d",karte[current_nummer].level);
  fl_set_input(fd_main->d_level,puffer);
  
  fl_set_input(fd_main->series_display,real_serien[karte[current_nummer].serie]);

  fl_set_input(fd_main->d_rarity,real_rarities[karte[current_nummer].rarity]);

  fl_set_input(fd_main->d_type,real_arten[karte[current_nummer].art]);
}

void credits(FL_OBJECT *ob, long data)
{
  fl_show_message("SpellDB is written by Michael Kleinhenz <kleinhen@unix-ag.uni-kl.de>",
                  "This program runs under the GNU General Public License. Please see",
                  "COPYING for details.");
}

void release_notes(FL_OBJECT *ob, long data)
{
  char	foo[MAXLEN];
  sprintf(foo,"%s Release - use at your own risk!", RELEASE);
  fl_show_message(versionstr,
                  foo,
                  "Report bugs to kleinhen@unix-ag.uni-kl.de");
}

void card_input(FL_OBJECT *ob, long data)
{
   const char* temp;
   
   temp=fl_get_input(fd_main->i_cardnumber);
   local_number=atoi(temp);
   if (strlen(temp)==3) fl_set_input_selected_range(fd_main->i_cardnumber,0,3); 
   update_data();
}

void minus(FL_OBJECT *ob, long data)
{
  if (karte[current_nummer].anzahl) 
      karte[current_nummer].anzahl--;
  else
      fl_ringbell(0);                 
  update_data();
  fl_set_input_selected_range(fd_main->i_cardnumber,0,3);
}

void plus(FL_OBJECT *ob, long data)
{
  printf("Current: %d",current_nummer);
  karte[current_nummer].anzahl++;
  update_data();
  fl_set_input_selected_range(fd_main->i_cardnumber,0,3);
}

void quit(FL_OBJECT *ob, long data)
{
  if(fl_show_question("Really quit?",0)) exit(0);
}

void save(FL_OBJECT *ob, long data)
{
  schreiben("database");
}

void make_wantlist(FL_OBJECT *ob, long data)
{
  int 		i;
  const char* 	filename;
  FILE*		datei;
  
  filename=fl_show_fselector("Wantlist filename?",".","*.txt","wantlist.txt");
  if (filename)
  {
    datei=fopen(filename,"w+");
    if (datei==NULL)
     {
       perror("ERROR - Opening file");
     }
  
    for (i=0; i<max_karten; i++)
      if (!karte[i].anzahl)
        {
          if (emit[karte[i].serie]==1) fprintf(datei,"%40s %3d\n",real_serien[karte[i].serie], karte[i].nummer);  
        }
    fclose(datei);
    fl_show_messages("Wantlist written..."); 
  }
}

void make_havelist(FL_OBJECT *ob, long data)
{
  int 		i;
  const char* 	filename;
  FILE*		datei;
  
  filename=fl_show_fselector("Havelist filename?",".","*.txt","havelist.txt");
  if (filename)
  { 
    datei=fopen(filename,"w+");
    if (datei==NULL)
     {
       perror("ERROR - Opening file");
     }
  
    for (i=0; i<max_karten; i++)
      if (karte[i].anzahl>keep)
        {
          if (emit[karte[i].serie]==1) fprintf(datei,"%40s %3d\n",real_serien[karte[i].serie], karte[i].nummer);  
        }
    fclose(datei);
    fl_show_messages("Havelist written...");
  }
}

void make_tradelist(FL_OBJECT *ob, long data)
{
  fl_show_fselector("Tradelist filename?",".","*.stl","tradelist.stl");
  fl_show_message("Sorry, not implemented yet!","","");
}

void compare_tradelist(FL_OBJECT *ob, long data)
{
  fl_deactivate_object(fd_report->report_text);
  fl_deactivate_form(fd_main->main);
  fl_show_fselector("Tradelist filename?",".","*.stl","tradelist.stl"); 
  fl_show_form(fd_report->report,FL_PLACE_CENTER,FL_FULLBORDER,"Tradelist Report");
}

void report_export(FL_OBJECT *ob, long data)
{

}

void report_cancel(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_report->report);  
  fl_activate_form(fd_main->main);    
}

void update_emitter()
{
 fl_set_button(fd_tradelists_setup->em_chase,emit[2]);
 fl_set_button(fd_tradelists_setup->em_1st,emit[1]);
 fl_set_button(fd_tradelists_setup->em_2nd,emit[3]);
 fl_set_button(fd_tradelists_setup->em_3rd,emit[4]);
 fl_set_button(fd_tradelists_setup->em_4th,emit[5]);
 fl_set_button(fd_tradelists_setup->em_no,emit[18]);
 fl_set_button(fd_tradelists_setup->em_pr,emit[21]);
 fl_set_button(fd_tradelists_setup->em_r,emit[22]);
 fl_set_button(fd_tradelists_setup->em_dl,emit[14]);
 fl_set_button(fd_tradelists_setup->em_fr,emit[16]);
 fl_set_button(fd_tradelists_setup->em_af,emit[10]);
 fl_set_button(fd_tradelists_setup->em_po,emit[19]);
 fl_set_button(fd_tradelists_setup->em_rr,emit[23]);
 fl_set_button(fd_tradelists_setup->em_un,emit[25]);
 fl_set_button(fd_tradelists_setup->em_br,emit[12]);
 fl_set_button(fd_tradelists_setup->em_ns,emit[8]);
 fl_set_button(fd_tradelists_setup->em_dc,emit[6]);
}

void setup(FL_OBJECT *ob, long data)
{
  fl_deactivate_form(fd_main->main);
  fl_show_form(fd_setup_form->setup_form,FL_PLACE_CENTER,FL_FULLBORDER,"Setup");
  update_emitter();
  fl_set_input(fd_general_setup->d_database_file,database_filename);
  fl_set_counter_precision(fd_general_setup->i_doubles,0);
  fl_set_counter_value(fd_general_setup->i_doubles,keep);
  fl_set_counter_bounds(fd_general_setup->i_doubles,0,10);
  fl_set_counter_step(fd_general_setup->i_doubles,1,2);
}

void series(FL_OBJECT *ob, long data)
{
  current_series=fl_get_menu(fd_main->m_series);  
  update_data();
}

void take_values()
{
  keep=fl_get_counter_value(fd_general_setup->i_doubles);
  strcpy(database_filename,fl_get_input(fd_general_setup->d_database_file));

  emit[2]=fl_get_button(fd_tradelists_setup->em_chase);
  emit[7]=emit[2];
  emit[9]=emit[2];
  emit[11]=emit[2];
  emit[13]=emit[2];
  emit[15]=emit[2];
  emit[17]=emit[2];
  emit[20]=emit[2];
  emit[24]=emit[2];
  emit[26]=emit[2];

  emit[1]=fl_get_button(fd_tradelists_setup->em_1st);
  emit[3]=fl_get_button(fd_tradelists_setup->em_2nd);
  emit[4]=fl_get_button(fd_tradelists_setup->em_3rd);
  emit[5]=fl_get_button(fd_tradelists_setup->em_4th);
  emit[18]=fl_get_button(fd_tradelists_setup->em_no);
  emit[21]=fl_get_button(fd_tradelists_setup->em_pr);
  emit[22]=fl_get_button(fd_tradelists_setup->em_r);
  emit[14]=fl_get_button(fd_tradelists_setup->em_dl);
  emit[16]=fl_get_button(fd_tradelists_setup->em_fr);
  emit[10]=fl_get_button(fd_tradelists_setup->em_af);
  emit[19]=fl_get_button(fd_tradelists_setup->em_po);
  emit[23]=fl_get_button(fd_tradelists_setup->em_rr);
  emit[25]=fl_get_button(fd_tradelists_setup->em_un);
  emit[12]=fl_get_button(fd_tradelists_setup->em_br);
  emit[8]=fl_get_button(fd_tradelists_setup->em_ns);
  emit[6]=fl_get_button(fd_tradelists_setup->em_dc);
}

void setup_ok(FL_OBJECT *ob, long data)
{
  take_values();
  fl_hide_form(fd_setup_form->setup_form);
  fl_activate_form(fd_main->main);
}

void setup_cancel(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_setup_form->setup_form);
  fl_activate_form(fd_main->main);
}

void save_setup(FL_OBJECT *ob, long data)
{
  int 		i;
  FILE*		datei;
  
  take_values();
  datei=fopen(setupfile,"w+");
  if (datei==NULL)
   {
     perror("ERROR - Writing setup");
   }
  fprintf(datei,"%d\n",keep);
  fprintf(datei,"%s\n",database_filename); 
  for (i=0;i<27;i++) fprintf(datei,"%d\n",emit[i]);
  fclose(datei); 
}

void select_database_file(FL_OBJECT *ob, long data)
{
  char 		foo[MAXLINE];
  const char 	*foo2;
  
  foo2=fl_show_fselector("Database filename?",".","*.*","database");
  if (foo2)
    {
      strcpy(foo,foo2);
      fl_set_input(fd_general_setup->d_database_file,foo);
    }
}

void titel_ok(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_titel->titel);
  fl_show_form(fd_main->main,FL_PLACE_CENTER,FL_FULLBORDER,versionstr);
}

