#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "forms.h"
#include "interface.h"
#include "spelldb.h"

#define MAXLEN 40

extern FD_deckbuilder		*fd_deckbuilder;
extern FD_main			*fd_main;
extern char	 		*real_serien[];
extern int             		max_karten;
extern struct karten 		karte[4000];
int				no_of_cards;
short int			current_db_series;
short int			deck[166];
short int			array_max;
char				deck_name[MAXLINE];
char				deck_comment[2048];

extern search(int a, int b);

void update_decktype()
{
  if (no_of_cards==55) fl_set_button(fd_deckbuilder->b_55,1);
    else fl_set_button(fd_deckbuilder->b_55,0);
  if (no_of_cards==75) fl_set_button(fd_deckbuilder->b_75,1);
    else fl_set_button(fd_deckbuilder->b_75,0);
  if (no_of_cards==110) fl_set_button(fd_deckbuilder->b_110,1);
    else fl_set_button(fd_deckbuilder->b_110,0);
  if (no_of_cards==165) fl_set_button(fd_deckbuilder->b_165,1);
    else fl_set_button(fd_deckbuilder->b_165,0);
}

void update_cardstock()
{
  int  i;
  char foo[MAXLEN];

  fl_clear_browser(fd_deckbuilder->d_cardstock);
  for (i=0;i<max_karten;i++)
     if (karte[i].serie==current_db_series)
       {
         sprintf(foo,"%3d - %s",karte[i].nummer,karte[i].name);
         fl_add_browser_line(fd_deckbuilder->d_cardstock,foo);
       }
}

void deckbuilder(FL_OBJECT *ob, long data)
{
  fl_deactivate_form(fd_main->main);
  fl_deactivate_object(fd_deckbuilder->deckbuilder_series);
  no_of_cards=55;
  update_decktype();
  current_db_series=1;      
  update_cardstock();
  array_max=0;
  fl_clear_browser(fd_deckbuilder->d_deckcards);
  fl_set_input_return(fd_deckbuilder->i_deckbuilder_comment,FL_RETURN_CHANGED);
  fl_set_input_return(fd_deckbuilder->i_deckbuilder_name,FL_RETURN_CHANGED);
  fl_set_input_maxchars(fd_deckbuilder->i_deckbuilder_name,MAXLINE);
  fl_set_input_maxchars(fd_deckbuilder->i_deckbuilder_comment,MAXLINE);
  fl_set_input(fd_deckbuilder->deckbuilder_series,real_serien[current_db_series]);     
  fl_set_input(fd_deckbuilder->i_deckbuilder_comment,"");
  fl_set_input(fd_deckbuilder->i_deckbuilder_name,"");
  fl_show_form(fd_deckbuilder->deckbuilder,FL_PLACE_CENTER,FL_FULLBORDER,"Deckbuilder"); 
}

void deckbuilder_save(FL_OBJECT *ob, long data)
{
  int           i;
  FILE*         datei; 

  datei=fopen(fl_show_fselector("Deck filename?",".","*.*","deck.sgd"),"w+");
  if (datei==NULL) perror("ERROR - Writing deckfile");
  fprintf(datei,"%d\n",no_of_cards);
  fprintf(datei,"%s\n",deck_name);
  fprintf(datei,"%d\n",array_max);
  for (i=0;i<array_max;i++) fprintf(datei,"%d\n",deck[i]); 
  fprintf(datei,"%s\n",deck_comment);
  fclose(datei); 
}

void deckbuilder_load(FL_OBJECT *ob, long data)
{
  int           i;
  FILE*         datei; 
  char		puffer[2048];
  char		comment_puffer[2048];
  char		foo[MAXLINE];

  i=0;
  strcpy(comment_puffer,"\0");
  datei=fopen(fl_show_fselector("Deck filename?",".","*.*","deck.sgd"),"r");
  if (datei==NULL) perror("ERROR - Reading deckfile");
  fl_clear_browser(fd_deckbuilder->d_deckcards);
  array_max=0;
  fgets(puffer,2048,datei);
  no_of_cards=atoi(puffer);
  fgets(deck_name,2048,datei);  
  fgets(puffer,2048,datei);  
  array_max=atoi(puffer);
  for (i=0;i<array_max;i++) 
    {
      fgets(puffer,MAXLEN,datei);
      deck[i]=atoi(puffer); 
    }
  while (!feof(datei) && !ferror(datei) && fgets(puffer,2048,datei))
    strcat(comment_puffer,puffer);
  strcpy(deck_comment,comment_puffer);
  fclose(datei);
  fl_clear_browser(fd_deckbuilder->d_deckcards);
  fl_set_input(fd_deckbuilder->i_deckbuilder_name,deck_name);
  fl_set_input(fd_deckbuilder->i_deckbuilder_comment,deck_comment);
  for (i=0;i<array_max;i++) 
    {
      sprintf(foo,"%s %3d - %s",real_serien[karte[deck[i]].serie],karte[deck[i]].nummer,karte[deck[i]].name);
      fl_add_browser_line(fd_deckbuilder->d_deckcards,foo); 
    }
  update_decktype();
}

void deckbuilder_export(FL_OBJECT *ob, long data)
{
  int           i;
  FILE*         datei; 

  datei=fopen(fl_show_fselector("Deck filename?",".","*.*","deck.txt"),"w+");
  if (datei==NULL) perror("ERROR - Writing deckfile");
  fprintf(datei,"Spellfire Deck: %s\n\n",deck_name);
  for (i=1;i<(array_max+1);i++) fprintf(datei,"%s\n",fl_get_browser_line(fd_deckbuilder->d_deckcards,i)); 
  fprintf(datei,"\nDeck Comment:\n");
  fprintf(datei,"%s\n",deck_comment);
  fprintf(datei,"\nMade with SpellDB\n");
  fclose(datei);
}

void deckbuilder_cancel(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_deckbuilder->deckbuilder);  
  fl_activate_form(fd_main->main);    
}

void deckbuilder_add(FL_OBJECT *ob, long data)
{
  int 	selection,absolute;
  char 	foo[MAXLINE]; 

  selection=fl_get_browser(fd_deckbuilder->d_cardstock);
  if (selection && fl_get_browser_maxline(fd_deckbuilder->d_deckcards)<=no_of_cards)
    {
      absolute=search(current_db_series,selection);
      sprintf(foo,"%s %3d - %s",real_serien[karte[absolute].serie],karte[absolute].nummer,karte[absolute].name);
      fl_add_browser_line(fd_deckbuilder->d_deckcards,foo);
      deck[array_max]=absolute;
      array_max++;
      /*
      printf("***%d***\n",array_max);
      int i;
      for (i=0;i<array_max;i++) printf("%d\n",deck[i]);  
      */
    }
  else fl_show_message("","Can't add to deck!","");
}

void deckbuilder_delete(FL_OBJECT *ob, long data)
{
  int   i,selection;
  
  selection=fl_get_browser(fd_deckbuilder->d_deckcards);
  if (selection) 
    {
      fl_delete_browser_line(fd_deckbuilder->d_deckcards,selection);
      for (i=selection-1;i<array_max;i++) deck[i]=deck[i+1];
      array_max--;
    }
    /*
    printf("***%d***\n",array_max);
    for (i=0;i<array_max;i++) printf("%d\n",deck[i]);  
    */
}

void db_series(FL_OBJECT *ob, long data)
{
  int foo;
  
  foo=fl_get_menu(fd_deckbuilder->b_deckbuilder_series);
  if (foo)
    {
      current_db_series=foo;
      fl_set_input(fd_deckbuilder->deckbuilder_series,real_serien[current_db_series]);
      update_cardstock(); 
    }
}

void deckbuilder_name(FL_OBJECT *ob, long data)
{
  const char* temp;
  temp=fl_get_input(fd_deckbuilder->i_deckbuilder_name);
  strcpy(deck_name,temp);
}

void deckbuilder_comment(FL_OBJECT *ob, long data)
{
  const char* temp;

  temp=fl_get_input(fd_deckbuilder->i_deckbuilder_comment);
  strcpy(deck_comment,temp);
}

void deckbuilder_check(FL_OBJECT *ob, long data)
{
  
}

void foofunction(FL_OBJECT *ob, long data) {}

void decktype(FL_OBJECT *ob, long data)
{
  if (ob==fd_deckbuilder->b_55) no_of_cards=55;
    else if (ob==fd_deckbuilder->b_75) no_of_cards=75;
           else if (ob==fd_deckbuilder->b_110) no_of_cards=110;
  	          else if (ob==fd_deckbuilder->b_165) no_of_cards=165;
  update_decktype();
}

