#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <forms.h>
#include <pwd.h>
#include <sys/types.h>  
#include "interface.h"
#include "image.h"
#include "spelldb.h"
#include "config.h"

FD_main 		*fd_main;
FD_titel 		*fd_titel;
FD_setup_form   	*fd_setup_form;
FD_general_setup	*fd_general_setup;
FD_tradelists_setup	*fd_tradelists_setup;
FD_report		*fd_report;
FD_deckbuilder		*fd_deckbuilder;

struct karten karte[4000];

int 		max_karten;
short 	int     current_series;
short 	int     current_nummer;
short 	int     local_number;
short	int	keep;
short 	int     emit[27]; 
char    	database_filename[MAXLINE];
char		versionstr[40];
char		setupfile[MAXLINE];

extern	char 	*real_serien[];
extern  char 	*real_arten[];
extern  char 	*real_welten[];
extern  char 	*real_rarities[];	

char *serien[]={
		" ","1ed","1edch","2ed","3ed","4ed","Dracon","Draconch","NIGHT",
		"NIGHTCH","art","artch","birth","birthch","dragon","dragonch",
		"for","forch","noed","power","powerch","promo","raven","rr",
		"rrch","under","underch",NULL
  	      };

char *arten[]={
		" ","Ally","Artifact","Blood Ability","Cleric Spell","Cleric",
		"Cleric/Avatar","Event","Hero","Holding","Magical Item",
		"Monster","Psioncist","Psionic Power","Psionicist","Realm",
		"Regent","Rule","Thief Ability","Thief","Unarmed Combat",
		"Wizard Spell","Wizard",NULL
              };

char *welten[]={
                 " ","AD&D","BR","DL","DS","FR","GH","RL",NULL
               };

char *rarities[]={
                   " ","C","M","R","U","VR",NULL
                 };


int einlesen(char* filename)
{
 FILE*	datei;
 char 	temp_serie[MAXLEN];
 char 	temp_art[MAXLEN];
 char 	temp_level[MAXLEN];
 char 	temp_welt[MAXLEN];
 char 	temp_rarity[MAXLEN];
 char 	temp_nummer[MAXLEN];
 char   temp_anzahl[MAXLEN];
 char 	temp_name[MAXLEN];
 char   temp[MAXLINE];
 
 int	n,i,z;
 
 datei=fopen(filename,"r");
 if (datei==NULL) 
 {
  perror("ERROR - Reading database");
  return ferror(datei);
 }
 n=0;
 i=0;
 while (!feof(datei) && !ferror(datei) && fgets(temp,MAXLINE,datei))
 {

//   printf("%s\n",temp);

   temp_serie[0]='\0';
   temp_nummer[0]='\0';
   temp_name[0]='\0';
   temp_anzahl[0]='\0';
   temp_art[0]='\0';
   temp_level[0]='\0';
   temp_welt[0]='\0';
   temp_rarity[0]='\0';

   sscanf(temp,"\"%[^\"]\",%[^,],\"%[^\"]\",%[^,],\"%[^\"]\",\"%[^\"]\",\"%[^\"]\",\"%[^\"]\"\n",
          temp_serie,temp_nummer,temp_name,temp_anzahl,temp_art,
          temp_level,temp_welt,temp_rarity);

//   printf("S: %s N: %s Name: %s Anz: %s Art: %s Lev: %s Welt: %s Rar: %s\n",
//          temp_serie,temp_nummer,temp_name,temp_anzahl,temp_art,
//          temp_level,temp_welt,temp_rarity);
 
   for (z=0;serien[z];z++)
      if (!strcmp(serien[z],temp_serie))
          karte[n].serie=z;    

   karte[n].nummer=atoi(temp_nummer);
   
   strncpy(karte[n].name,temp_name,MAXLEN-1);
   
   karte[n].anzahl=atoi(temp_anzahl);
   
   for (z=0;arten[z];z++)
      if (!strcmp(arten[z],temp_art))
          karte[n].art=z;    

   karte[n].level=atoi(temp_level);

   for (z=0;welten[z];z++)
      if (!strcmp(welten[z],temp_welt))
          karte[n].welt=z;    

   for (z=0;rarities[z];z++)
      if (!strcmp(rarities[z],temp_rarity))
          karte[n].rarity=z;    
   
   n++;
 }
   n--;
   max_karten=n;

//   printf("S: %d N: %d Name: %s Anz: %d Art: %d Lev: %d Welt: %d Rar: %d\n",
//          karte[n].serie,karte[n].nummer,karte[n].name,karte[n].anzahl,
//          karte[n].art,karte[n].level,karte[n].welt,karte[n].rarity);
 
 
 if (ferror(datei) &&!feof(datei)) 
    {
      perror("ERROR - Reading database");  
      return ferror(datei); 
    }
 fclose(datei);
 return 0;
};

int schreiben(char* filename)
{
 FILE*	datei;
 int	i;
 char   temp_level[MAXLEN];
 
 datei=fopen(filename,"w+");
 if (datei==NULL) 
 {
  perror("ERROR - Reading database");
  return ferror(datei);
 }
 for (i=0;i<=max_karten;i++)
  {
    if (karte[i].level==0) strncpy(temp_level," ",MAXLEN); 
                           else sprintf(temp_level,"%d",karte[i].level);
    fprintf(datei,"\"%s\",%d,\"%s\",%d,\"%s\",\"%s\",\"%s\",\"%s\"\n",
          serien[karte[i].serie],karte[i].nummer,karte[i].name,karte[i].anzahl,
          arten[karte[i].art],temp_level,welten[karte[i].welt],
          rarities[karte[i].rarity]);
  }
 fclose(datei);
 return 0; 
};

int main(int argc, char *argv[])
{
   char 		puffer[MAXLEN];
   int  		i;
   FILE*        	datei;  
   struct passwd	*userpw;

   fl_initialize(&argc, argv, 0, 0, 0);
   fd_main = create_form_main();
   fd_titel = create_form_titel();
   fd_setup_form = create_form_setup_form();
   fd_general_setup = create_form_general_setup();
   fd_tradelists_setup = create_form_tradelists_setup();
   fd_report = create_form_report();
   fd_deckbuilder = create_form_deckbuilder(); 

   fl_set_menu(fd_main->m_series,"1st Edition|1st Edition Chase|2nd Edition|3rd Edition|4th Edition|Draconomicon|Draconomicon Chase|NightStalkers|Nightstalkers Chase|Artifacts|Artifacts Chase|Birthright|Birthright Chase|Dragonlance|Dragonlance Chase|Forgotten Realms|Forgotten Realms Chase|No Edition|Powers|Powers Chase|Promos|Ravenloft|Runes and Ruins|Runes and Ruins Chase|Underdark|Underdark Chase");
   fl_set_input_maxchars(fd_main->i_cardnumber,4);
   fl_set_input_return(fd_main->i_cardnumber,FL_RETURN_ALWAYS);
   
   fl_deactivate_object(fd_main->d_name);
   fl_deactivate_object(fd_main->d_welt);
   fl_deactivate_object(fd_main->series_display);
   fl_deactivate_object(fd_main->d_rarity);
   fl_deactivate_object(fd_main->d_level);
   fl_deactivate_object(fd_main->d_inventory);
   fl_deactivate_object(fd_main->d_type);
   
   fl_addto_tabfolder(fd_setup_form->setup_folder,"General",fd_general_setup->general_setup);
   fl_addto_tabfolder(fd_setup_form->setup_folder,"Tradelists",fd_tradelists_setup->tradelists_setup);

   fl_set_menu(fd_deckbuilder->b_deckbuilder_series,"1st Edition|1st Edition Chase|2nd Edition|3rd Edition|4th Edition|Draconomicon|Draconomicon Chase|NightStalkers|Nightstalkers Chase|Artifacts|Artifacts Chase|Birthright|Birthright Chase|Dragonlance|Dragonlance Chase|Forgotten Realms|Forgotten Realms Chase|No Edition|Powers|Powers Chase|Promos|Ravenloft|Runes and Ruins|Runes and Ruins Chase|Underdark|Underdark Chase");


   /* READ SETUP */

   userpw=getpwuid(getuid());
   if (userpw==NULL)
     {
       fprintf(stderr,"Error: getting UID failed");
       exit(1);
     }
   sprintf(puffer,"%s/%s",userpw->pw_dir,SETUP_PATH);
   strcpy(setupfile,puffer);
   datei=fopen(puffer,"r");  
   if (datei==NULL) 
     {
       datei=fopen(puffer,"w+");
       if (datei==NULL) perror("ERROR - Writing new setup");
       fprintf(datei,"%d\n",1);
       sprintf(puffer,"%s/%s",userpw->pw_dir,".spelldb");
       fprintf(datei,"%s\n",puffer);
       for (i=0;i<27;i++) fprintf(datei,"%d\n",1);
     }
   fscanf(datei,"%s\n",puffer);
   keep=atoi(puffer);
   fscanf(datei,"%s\n",database_filename);  
   for (i=0;i<27;i++) 
     {
       fscanf(datei,"%s\n",puffer);
       emit[i]=atoi(puffer);
     }  
   fclose(datei);

   /* READ SETUP END */

   einlesen(database_filename);

   current_series=1;
   current_nummer=0;
   local_number=1;

   fl_set_input(fd_main->d_name,karte[current_nummer].name);
   sprintf(puffer,"%d",karte[current_nummer].anzahl);
   fl_set_input(fd_main->d_inventory,puffer); 
   fl_set_input(fd_main->d_welt,real_welten[karte[current_nummer].welt]);
   sprintf(puffer,"%d",karte[current_nummer].level);
   fl_set_input(fd_main->d_level,puffer);             
   fl_set_input(fd_main->series_display,real_serien[karte[current_nummer].serie]);
   fl_set_input(fd_main->d_rarity,real_rarities[karte[current_nummer].rarity]);
   fl_set_input(fd_main->d_type,real_arten[karte[current_nummer].art]);     
    
   /* show the first form */
   fl_set_pixmap_data(fd_titel->bild,image);
   strcpy(versionstr,"SpellDB ");
   strcat(versionstr,VERSION);
   fl_show_form(fd_titel->titel,FL_PLACE_CENTER,FL_FULLBORDER,versionstr);
   fl_do_forms();
   return 0;
}
